#include <iostream>
#include <vector>
#include <string>

using namespace std;
int main() {
    int labs, n, q;

    cin >> labs >>n >> q;

    vector<int> desks(labs+1);
    vector<int> monitors(labs+1);

    for(int i = 0; i < labs; i++){
        cin >> desks[i+1];
    }

    for(int i = 0; i < labs; i++){
        cin >> monitors[i+1];
    }

    vector<vector<int>> pairs;
    pairs.resize(labs+1);

    for(int i = 0; i < n; i++){
        int a, b;
        cin >> a >> b;
        pairs[a].push_back(b);
        pairs[b].push_back(a);
    }

    vector<int> desks2(labs+1);
    vector<int> monitors2(labs+1);

    for(int i = 0; i < labs+1; i++){
        int sumOfDesks = desks[i];
        int sumOfMonitors = monitors[i];

        for(size_t j = 0; j < pairs[i].size(); j++){
            sumOfDesks+=desks[pairs[i][j]];
            sumOfMonitors+=monitors[pairs[i][j]];
        }
        desks2[i] = sumOfDesks;
        monitors2[i] = sumOfMonitors;
    }


    for(int i = 0; i < q; i++){
        string s;
        cin >> s;

        if(s == "check"){
            int roomNum;
            cin >> roomNum;

            if(monitors2[roomNum] > desks2[roomNum])
                cout << "monitors" << endl;
            else if(monitors2[roomNum] < desks2[roomNum])
                cout << "desks" << endl;
            else
                cout << "same" << endl;

        }
        else{
            int count, lab;
            string what;

            cin >> count >> what >> lab;

            if(what == "monitor"){
                monitors2[lab] += count;
                for(size_t j = 0; j < pairs[lab].size(); j++){
                    monitors2[pairs[lab][j]] += count;
                }
            }
            else {
                desks2[lab] += count;
                for (size_t j = 0; j < pairs[lab].size(); j++) {
                    desks2[pairs[lab][j]] += count;
                }
            }
        }

    }

    return 0;
}
